/////////////////////////////////////////////////////////////////////////////
// Name:        BoardWorkerThread.cpp
// Purpose:     
// Author:      NDA
// Modified by: 
// Created:     11/24/05 15:04:29
// RCS-ID:      
// Copyright:   CAEN S.p.A. All rights reserved
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 11/24/05 15:04:29

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "boardworkerthread.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include <wx/datetime.h>

#include "generic_board.h"
#include "boardworkerthread.h"
#include "appsettings.h"

BoardWorkerThread::BoardWorkerThread(GenericBoard* parent)
{
	this->m_parent= parent;
}

BoardWorkerThread::~BoardWorkerThread(void)
{
}

wxThread::ExitCode BoardWorkerThread::Entry( void)
{
	const int SW_TRIGGER_INTERVAL_MSEC= 1;

	this->m_next_sw_trigger= wxDateTime::UNow();
	while( !this->TestDestroy())
	{
		//
		// Get channels' samples
		for( size_t i= 0; ( i< this->m_parent->m_channel_array.GetCount())&& !this->TestDestroy(); i++)
		{
			GenericBoardChannel *board_channel= ( GenericBoardChannel *)this->m_parent->m_channel_array[i];
			board_channel->ReadSamples( this->m_parent->m_is_recording);
			this->Sleep( 1);
		}
		//
		// Software autoretrig.
		if(( this->m_parent->m_p_app_settings->m_trigger_msk& (int)AppSettings::SW_AUTO_TRIGGER_MSK)&& !this->TestDestroy())
		{
			if( wxDateTime::UNow()>= this->m_next_sw_trigger)
			{
				// Update next trigger timer
				this->m_next_sw_trigger= wxDateTime::UNow().Add( wxTimeSpan( 0, 0, 0, SW_TRIGGER_INTERVAL_MSEC));

				// Send SW retrigger
				this->m_parent->WriteSoftwareTrigger( );
			}
		}
	}
    this->m_parent->m_thread_exited= true;
	return (wxThread::ExitCode)0;
}

