/////////////////////////////////////////////////////////////////////////////
// Name:        mainframe.cpp
// Purpose:     
// Author:      NDA
// Modified by: 
// Created:     04/03/06 14:18:40
// RCS-ID:      
// Copyright:   CAEN S.p.A All rights reserved.
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 04/03/06 14:18:40
#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "mainframe.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include <wx/cmndata.h>
#include <wx/colordlg.h>
#include <wx/log.h>
#include <wx/dir.h>
#include <wx/dirdlg.h> 
#include <wx/generic/dirdlgg.h>
#include <wx/datetime.h>
#include <wx/list.h>
#include <wx/filename.h>

////@begin includes
////@end includes

#include "generic_board.h"
#include "common_ch_control.h"
#include "trigger_ch_control.h"
#include "view_ch_control.h"
#include "record_ch_control.h"
#include "drawing_panel.h"
#include "infodialog.h"
#include "cursor_ch_control.h"
#include "mainframe.h"

////@begin XPM images
////@end XPM images

static const double SEC_PER_DIV_TABLE[]=
{
	0.000000100,		// 100 nS
	0.000000500,		// 500 nS
	0.000001000,		//   1 uS
	0.000005000,		//   5 uS
	0.000010000,		//  10 uS
	0.000050000,		//  50 uS
	0.000100000,		// 100 uS
	0.000500000,		// 500 uS
	0.001000000,		//   1 mS
	0.005000000,		//   5 mS
};

DrawingPanel* MainFrame::g_scope_panel= NULL;
wxStatusBar* MainFrame::g_main_statusbar= NULL;

/*!
* MainFrame type definition
*/

IMPLEMENT_CLASS( MainFrame, wxFrame )

/*!
* MainFrame event table definition
*/

BEGIN_EVENT_TABLE( MainFrame, wxFrame )

////@begin MainFrame event table entries
    EVT_CLOSE( MainFrame::OnCloseWindow )
    EVT_SIZE( MainFrame::OnSize )

    EVT_SASH_DRAGGED( ID_SASHLAYOUTWINDOW2, MainFrame::OnBottomWindowSashDragged )

    EVT_TOGGLEBUTTON( ID_COMMON_RUN_TOGGLEBUTTON, MainFrame::OnCommonRunTogglebuttonClick )

    EVT_TOGGLEBUTTON( ID_FRONT_PANEL_NIM_TOGGLEBUTTON, MainFrame::OnFrontPanelNimTogglebuttonClick )

    EVT_CHOICE( ID_SIZE_X_CHOICE, MainFrame::OnSizeXChoiceSelected )

    EVT_CHOICE( ID_SEC_PER_DIV_CHOICE, MainFrame::OnSecPerDivChoiceSelected )

    EVT_CHECKBOX( ID_EXT_CLOCK_CHECKBOX, MainFrame::OnExtClockCheckboxClick )

    EVT_SPINCTRL( ID_EXT_CLOCK_SPINCTRL, MainFrame::OnExtClockSpinctrlUpdated )
    EVT_TEXT_ENTER( ID_EXT_CLOCK_SPINCTRL, MainFrame::OnExtClockSpinctrlTextUpdated )

    EVT_TOGGLEBUTTON( ID_TRIGGER_EXT_TOGGLEBUTTON, MainFrame::OnTriggerExtTogglebuttonClick )

    EVT_TOGGLEBUTTON( ID_TRIGGER_AUTO_TOGGLEBUTTON, MainFrame::OnTriggerAutoTogglebuttonClick )

    EVT_BUTTON( ID_TRIGGER_FORCE_BUTTON, MainFrame::OnTriggerForceButtonClick )

    EVT_SPINCTRL( ID_TRIGGER_POST_SPINCTRL, MainFrame::OnTriggerPostSpinctrlUpdated )
    EVT_TEXT_ENTER( ID_TRIGGER_POST_SPINCTRL, MainFrame::OnTriggerPostSpinctrlTextUpdated )

    EVT_CHECKBOX( ID_TRIGGER_POSITION_KEEP_CHECKBOX, MainFrame::OnTriggerPositionKeepCheckboxClick )

    EVT_CHOICE( ID_TRIGGER_EDGE_CHOICE, MainFrame::OnTriggerEdgeChoiceSelected )

    EVT_TOGGLEBUTTON( ID_RECORDTOGGLEBUTTON, MainFrame::OnRecordtogglebuttonClick )

    EVT_TEXT( ID_RECORDDIRTEXTCTRL, MainFrame::OnRecorddirtextctrlUpdated )
    EVT_TEXT_ENTER( ID_RECORDDIRTEXTCTRL, MainFrame::OnRecorddirtextctrlEnter )

    EVT_BUTTON( ID_RECORDDIRBUTTON, MainFrame::OnRecorddirbuttonClick )

    EVT_SASH_DRAGGED( ID_SASHLAYOUTWINDOW, MainFrame::OnLeftWindowSashDragged )

    EVT_BUTTON( ID_BACK_CHOOSE_COLOR_BUTTON, MainFrame::OnBackChooseColorButtonClick )

    EVT_SPINCTRL( ID_OFFSET_SEC_SPINCTRL, MainFrame::OnOffsetSecSpinctrlUpdated )
    EVT_TEXT_ENTER( ID_OFFSET_SEC_SPINCTRL, MainFrame::OnOffsetSecSpinctrlTextUpdated )

    EVT_BUTTON( ID_GRID_CHOOSE_COLOR_BUTTON, MainFrame::OnGridChooseColorButtonClick )

    EVT_SPINCTRL( ID_GRID_LINE_WIDTH_SPINCTRL, MainFrame::OnGridLineWidthSpinctrlUpdated )
    EVT_TEXT_ENTER( ID_GRID_LINE_WIDTH_SPINCTRL, MainFrame::OnGridLineWidthSpinctrlTextUpdated )

    EVT_CHOICE( ID_GRID_LINE_TYPE_CHOICE, MainFrame::OnGridLineTypeChoiceSelected )

    EVT_MENU( ID_EXIT_TOOL, MainFrame::OnExitToolClick )

    EVT_MENU( ID_VIEW_LEFT_TOOL, MainFrame::OnViewLeftToolClick )

    EVT_MENU( ID_VIEW_BOTTOM_TOOL, MainFrame::OnViewBottomToolClick )

    EVT_MENU( ID_HELP_TOOL, MainFrame::OnHelpToolClick )

////@end MainFrame event table entries

END_EVENT_TABLE()


/*!
* MainFrame constructors
*/

MainFrame::MainFrame( )
{
}

MainFrame::MainFrame( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
	Create( parent, id, caption, pos, size, style );
}

/*!
* MainFrame creator
*/

bool MainFrame::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
	////@begin MainFrame member initialisation
    m_bottom_pane = NULL;
    m_common_settings_notebook = NULL;
    m_common_panel = NULL;
    m_common_main_sizer = NULL;
    m_common_run_control = NULL;
    m_common_TTL_control = NULL;
    m_size_X_control = NULL;
    m_sec_per_div_control = NULL;
    m_use_ext_clock_control = NULL;
    m_ext_clock_control = NULL;
    m_trigger_panel = NULL;
    m_trigger_main_sizer = NULL;
    m_trigger_ext_control = NULL;
    m_trigger_auto_control = NULL;
    m_force_trigger_control = NULL;
    m_trigger_post_control = NULL;
    m_trigger_position_keep_control = NULL;
    m_trigger_edge_control = NULL;
    m_record_panel = NULL;
    m_record_main_sizer = NULL;
    m_record_start_stop_control = NULL;
    m_record_folder_sizer = NULL;
    m_record_dir_control = NULL;
    m_record_dir_browse_button = NULL;
    m_left_pane = NULL;
    m_specific_settings_notebook = NULL;
    m_view_panel = NULL;
    m_view_main_sizer = NULL;
    m_back_color_control = NULL;
    m_main_sizer_text = NULL;
    m_offset_sec_control = NULL;
    m_grid_color_control = NULL;
    m_grid_line_width_control = NULL;
    m_grid_line_type_control = NULL;
    m_cursor_panel = NULL;
    m_cursor_main_sizer = NULL;
    m_top_pane = NULL;
    m_scope_notebook = NULL;
    m_main_toolbar = NULL;
    m_main_statusbar = NULL;
	////@end MainFrame member initialisation

	////@begin MainFrame creation
    wxFrame::Create( parent, id, caption, pos, size, style );

    this->SetFont(wxFont(9, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Verdana")));
    CreateControls();
    SetIcon(GetIconResource(wxT("scope2.png")));
    Centre();
	////@end MainFrame creation

	//
	// Load application settings
	this->m_app_settings= new AppSettings( MainFrame::ScopeRefresh);

	// 
	// Load Application settings
	if( !this->m_app_settings->Load( ))
	{
		wxLogError( _("Error loading application settings ..."));
		return false;
	}
	this->m_scope_panel->m_app_settings= this->m_app_settings;

	//
	// Create dynamic controls
	if( !this->CreateDynControls())
		return false;

	if( !this->UpdateControls())
		return false;

    Centre();

	//for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	//{
	//	(( GenericBoard *)this->m_app_settings->m_board_array[i])->DoStartRunning();
	//}

	return true;
}
bool MainFrame::CreateDynControls()
{
    wxBoxSizer* common_panel_HBoxSizer= new wxBoxSizer( wxHORIZONTAL);
	this->m_common_main_sizer->Add( common_panel_HBoxSizer, 1, wxGROW|wxALL, 5);

    wxBoxSizer* trigger_panel_HBoxSizer= new wxBoxSizer( wxHORIZONTAL);
	this->m_trigger_main_sizer->Add( trigger_panel_HBoxSizer, 1, wxGROW|wxALL, 5);

    wxBoxSizer* record_panel_HBoxSizer= new wxBoxSizer( wxHORIZONTAL);
	this->m_record_main_sizer->Add( record_panel_HBoxSizer, 1, wxGROW|wxALL, 5);

    wxBoxSizer* view_panel_VBoxSizer= new wxBoxSizer( wxVERTICAL);
	this->m_view_main_sizer->Add( view_panel_VBoxSizer, 1, wxGROW|wxALL, 5);

    wxBoxSizer* cursor_panel_VBoxSizer= new wxBoxSizer( wxVERTICAL);
	this->m_cursor_main_sizer->Add( cursor_panel_VBoxSizer, 1, wxGROW|wxALL, 5);

	// Channel controls
	int ch_count= 0;
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		for( size_t j= 0; j< ((GenericBoard*)this->m_app_settings->m_board_array[i])->m_channel_array.GetCount(); j++, ch_count++)
		{
			//
			// Common controls
			CommonChControl *common_ch_ctrl= new CommonChControl( this->m_common_panel);
			common_ch_ctrl->SetupBoard( (GenericBoard*)this->m_app_settings->m_board_array[i], j, ch_count);

			common_panel_HBoxSizer->Add( common_ch_ctrl, 0, wxGROW|wxALL, 1);
			//
			// Trigger controls
			TriggerChControl *trigger_ch_ctrl= new TriggerChControl( this->m_trigger_panel);
			trigger_ch_ctrl->SetupBoard( (GenericBoard*)this->m_app_settings->m_board_array[i], j, ch_count);

			trigger_panel_HBoxSizer->Add( trigger_ch_ctrl, 0, wxGROW|wxALL, 1);
			//
			// Record controls
			RecordChControl *record_ch_ctrl= new RecordChControl( this->m_record_panel);
			record_ch_ctrl->SetupBoard( (GenericBoard*)this->m_app_settings->m_board_array[i], j, ch_count);

			record_panel_HBoxSizer->Add( record_ch_ctrl, 0, wxGROW|wxALL, 1);
			//
			// View controls
			ViewChControl *view_ch_ctrl= new ViewChControl( this->m_view_panel);
			view_ch_ctrl->SetupBoard( (GenericBoard*)this->m_app_settings->m_board_array[i], j, ch_count);

			view_panel_VBoxSizer->Add( view_ch_ctrl, 0, wxGROW|wxALL, 1);
			//
			// Cursor controls
			CursorChControl *cursor_ch_ctrl= new CursorChControl( this->m_cursor_panel);
			cursor_ch_ctrl->SetupBoard( (GenericBoard*)this->m_app_settings->m_board_array[i], j, ch_count);

			cursor_panel_VBoxSizer->Add( cursor_ch_ctrl, 0, wxGROW|wxALL, 1);
		}
	}

	return true;
}

/*!
* Control creation for MainFrame
*/

void MainFrame::CreateControls()
{    
	////@begin MainFrame content construction
    // Generated by DialogBlocks, 23/10/2006 10:12:19 (unregistered)

    MainFrame* itemFrame1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemFrame1->SetSizer(itemBoxSizer2);

    m_bottom_pane = new wxSashLayoutWindow( itemFrame1, ID_SASHLAYOUTWINDOW2, wxDefaultPosition, itemFrame1->ConvertDialogToPixels(wxSize(66, 110)), wxSW_3DBORDER|wxSW_3DSASH|wxNO_BORDER );
    m_bottom_pane->SetSashVisible(wxSASH_TOP, true);
    m_bottom_pane->SetOrientation(wxLAYOUT_HORIZONTAL);
    m_bottom_pane->SetAlignment(wxLAYOUT_BOTTOM);
    m_bottom_pane->SetDefaultSize(itemFrame1->ConvertDialogToPixels(wxSize(66, 110)));
    m_bottom_pane->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Verdana")));
    itemBoxSizer2->Add(m_bottom_pane, 0, wxGROW|wxALL, 0);

    m_common_settings_notebook = new wxNotebook( m_bottom_pane, ID_BOTTOM_NOTEBOOK, wxDefaultPosition, wxDefaultSize, wxNB_TOP );

    m_common_panel = new wxScrolledWindow( m_common_settings_notebook, ID_COMMON_SCROLLEDWINDOW, wxDefaultPosition, m_common_settings_notebook->ConvertDialogToPixels(wxSize(133, 43)), wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    m_common_panel->SetScrollbars(1, 1, 1, 1);
    m_common_main_sizer = new wxBoxSizer(wxHORIZONTAL);
    m_common_panel->SetSizer(m_common_main_sizer);

    wxBoxSizer* itemBoxSizer7 = new wxBoxSizer(wxVERTICAL);
    m_common_main_sizer->Add(itemBoxSizer7, 0, wxALIGN_TOP|wxALL, 5);
    m_common_run_control = new wxToggleButton( m_common_panel, ID_COMMON_RUN_TOGGLEBUTTON, _("Run"), wxDefaultPosition, wxDefaultSize, 0 );
    m_common_run_control->SetValue(false);
    m_common_run_control->SetHelpText(_("Start/Stop acqusition"));
    if (ShowToolTips())
        m_common_run_control->SetToolTip(_("Start/Stop acqusition"));
    m_common_run_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemBoxSizer7->Add(m_common_run_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticBox* itemStaticBoxSizer9Static = new wxStaticBox(m_common_panel, wxID_ANY, _("Ext. signals"));
    wxStaticBoxSizer* itemStaticBoxSizer9 = new wxStaticBoxSizer(itemStaticBoxSizer9Static, wxHORIZONTAL);
    itemBoxSizer7->Add(itemStaticBoxSizer9, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT, 2);
    m_common_TTL_control = new wxToggleButton( m_common_panel, ID_FRONT_PANEL_NIM_TOGGLEBUTTON, _("TTL"), wxDefaultPosition, wxDefaultSize, 0 );
    m_common_TTL_control->SetValue(false);
    m_common_TTL_control->SetHelpText(_("Set external signal standard  TTL\\NIM"));
    if (ShowToolTips())
        m_common_TTL_control->SetToolTip(_("Set external signal standard  TTL\\NIM"));
    m_common_TTL_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer9->Add(m_common_TTL_control, 0, wxALIGN_TOP|wxALL, 5);

    wxBoxSizer* itemBoxSizer11 = new wxBoxSizer(wxVERTICAL);
    m_common_main_sizer->Add(itemBoxSizer11, 0, wxALIGN_TOP|wxALL, 5);
    wxStaticBox* itemStaticBoxSizer12Static = new wxStaticBox(m_common_panel, wxID_ANY, _("Buffer size"));
    wxStaticBoxSizer* itemStaticBoxSizer12 = new wxStaticBoxSizer(itemStaticBoxSizer12Static, wxHORIZONTAL);
    itemBoxSizer11->Add(itemStaticBoxSizer12, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT, 2);
    wxString* m_size_X_controlStrings = NULL;
    m_size_X_control = new wxChoice( m_common_panel, ID_SIZE_X_CHOICE, wxDefaultPosition, m_common_panel->ConvertDialogToPixels(wxSize(64, -1)), 0, m_size_X_controlStrings, 0 );
    m_size_X_control->SetHelpText(_("Horizontal size"));
    if (ShowToolTips())
        m_size_X_control->SetToolTip(_("Horizontal size"));
    m_size_X_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Arial")));
    itemStaticBoxSizer12->Add(m_size_X_control, 1, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 3);

    wxStaticBox* itemStaticBoxSizer14Static = new wxStaticBox(m_common_panel, wxID_ANY, _("Sec/Div"));
    wxStaticBoxSizer* itemStaticBoxSizer14 = new wxStaticBoxSizer(itemStaticBoxSizer14Static, wxHORIZONTAL);
    itemBoxSizer11->Add(itemStaticBoxSizer14, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT, 2);
    wxString* m_sec_per_div_controlStrings = NULL;
    m_sec_per_div_control = new wxChoice( m_common_panel, ID_SEC_PER_DIV_CHOICE, wxDefaultPosition, m_common_panel->ConvertDialogToPixels(wxSize(64, -1)), 0, m_sec_per_div_controlStrings, 0 );
    m_sec_per_div_control->SetHelpText(_("Seconds per division"));
    if (ShowToolTips())
        m_sec_per_div_control->SetToolTip(_("Seconds per division"));
    m_sec_per_div_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Arial")));
    itemStaticBoxSizer14->Add(m_sec_per_div_control, 1, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 3);

    wxStaticBox* itemStaticBoxSizer16Static = new wxStaticBox(m_common_panel, wxID_ANY, _("Ext. clock"));
    wxStaticBoxSizer* itemStaticBoxSizer16 = new wxStaticBoxSizer(itemStaticBoxSizer16Static, wxHORIZONTAL);
    itemBoxSizer11->Add(itemStaticBoxSizer16, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT, 2);
    m_use_ext_clock_control = new wxCheckBox( m_common_panel, ID_EXT_CLOCK_CHECKBOX, _T(""), wxDefaultPosition, wxDefaultSize, 0 );
    m_use_ext_clock_control->SetValue(false);
    m_use_ext_clock_control->SetHelpText(_("Use external clock"));
    if (ShowToolTips())
        m_use_ext_clock_control->SetToolTip(_("Use external clock"));
    itemStaticBoxSizer16->Add(m_use_ext_clock_control, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_ext_clock_control = new wxSpinCtrl( m_common_panel, ID_EXT_CLOCK_SPINCTRL, _T("1"), wxDefaultPosition, m_common_panel->ConvertDialogToPixels(wxSize(33, -1)), wxSP_ARROW_KEYS, 1, 100, 1 );
    m_ext_clock_control->SetHelpText(_("Set external sample rate (MHz)"));
    if (ShowToolTips())
        m_ext_clock_control->SetToolTip(_("Set external sample rate (MHz)"));
    itemStaticBoxSizer16->Add(m_ext_clock_control, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 1);

    wxStaticBox* itemStaticBoxSizer19Static = new wxStaticBox(m_common_panel, wxID_ANY, _("Channels"));
    wxStaticBoxSizer* itemStaticBoxSizer19 = new wxStaticBoxSizer(itemStaticBoxSizer19Static, wxVERTICAL);
    m_common_main_sizer->Add(itemStaticBoxSizer19, 0, wxGROW|wxALL, 5);
    wxStaticText* itemStaticText20 = new wxStaticText( m_common_panel, wxID_STATIC, _("Enable:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText20->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer19->Add(itemStaticText20, 0, wxALIGN_RIGHT|wxLEFT|wxTOP|wxBOTTOM|wxADJUST_MINSIZE, 5);

    wxStaticText* itemStaticText21 = new wxStaticText( m_common_panel, wxID_STATIC, _("DAC offset:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText21->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer19->Add(itemStaticText21, 0, wxALIGN_RIGHT|wxLEFT|wxTOP|wxBOTTOM|wxADJUST_MINSIZE, 18);

    wxStaticText* itemStaticText22 = new wxStaticText( m_common_panel, wxID_STATIC, _("Medium (mV):"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText22->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer19->Add(itemStaticText22, 0, wxALIGN_RIGHT|wxLEFT|wxTOP|wxBOTTOM|wxADJUST_MINSIZE, 5);

    wxStaticText* itemStaticText23 = new wxStaticText( m_common_panel, wxID_STATIC, _("Overload:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText23->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer19->Add(itemStaticText23, 0, wxALIGN_RIGHT|wxLEFT|wxTOP|wxADJUST_MINSIZE, 5);

    m_common_panel->FitInside();
    m_common_settings_notebook->AddPage(m_common_panel, _("COMMON"));

    m_trigger_panel = new wxScrolledWindow( m_common_settings_notebook, ID_TRIGGER_SCROLLEDWINDOW, wxDefaultPosition, m_common_settings_notebook->ConvertDialogToPixels(wxSize(133, 43)), wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    m_trigger_panel->SetScrollbars(1, 1, 1, 1);
    m_trigger_main_sizer = new wxBoxSizer(wxHORIZONTAL);
    m_trigger_panel->SetSizer(m_trigger_main_sizer);

    wxBoxSizer* itemBoxSizer26 = new wxBoxSizer(wxVERTICAL);
    m_trigger_main_sizer->Add(itemBoxSizer26, 0, wxALIGN_TOP|wxALL, 5);
    m_trigger_ext_control = new wxToggleButton( m_trigger_panel, ID_TRIGGER_EXT_TOGGLEBUTTON, _("Ext."), wxDefaultPosition, wxDefaultSize, 0 );
    m_trigger_ext_control->SetValue(false);
    m_trigger_ext_control->SetHelpText(_("Enable/Disable external trigger"));
    if (ShowToolTips())
        m_trigger_ext_control->SetToolTip(_("Enable/Disable external trigger"));
    m_trigger_ext_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemBoxSizer26->Add(m_trigger_ext_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    m_trigger_auto_control = new wxToggleButton( m_trigger_panel, ID_TRIGGER_AUTO_TOGGLEBUTTON, _("Auto"), wxDefaultPosition, wxDefaultSize, 0 );
    m_trigger_auto_control->SetValue(false);
    m_trigger_auto_control->SetHelpText(_("Enable/Disable auto trigger"));
    if (ShowToolTips())
        m_trigger_auto_control->SetToolTip(_("Enable/Disable auto trigger"));
    m_trigger_auto_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemBoxSizer26->Add(m_trigger_auto_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    m_force_trigger_control = new wxButton( m_trigger_panel, ID_TRIGGER_FORCE_BUTTON, _("Force"), wxDefaultPosition, wxDefaultSize, 0 );
    m_force_trigger_control->SetHelpText(_("Force trigger"));
    if (ShowToolTips())
        m_force_trigger_control->SetToolTip(_("Force trigger"));
    m_force_trigger_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemBoxSizer26->Add(m_force_trigger_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer30 = new wxBoxSizer(wxVERTICAL);
    m_trigger_main_sizer->Add(itemBoxSizer30, 0, wxALIGN_TOP|wxALL, 5);
    wxStaticBox* itemStaticBoxSizer31Static = new wxStaticBox(m_trigger_panel, wxID_ANY, _("Post Trigger"));
    wxStaticBoxSizer* itemStaticBoxSizer31 = new wxStaticBoxSizer(itemStaticBoxSizer31Static, wxVERTICAL);
    itemBoxSizer30->Add(itemStaticBoxSizer31, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT|wxTOP, 0);
    m_trigger_post_control = new wxSpinCtrl( m_trigger_panel, ID_TRIGGER_POST_SPINCTRL, _T("0"), wxDefaultPosition, m_trigger_panel->ConvertDialogToPixels(wxSize(60, -1)), wxSP_ARROW_KEYS, 0, 999999999, 0 );
    m_trigger_post_control->SetHelpText(_("Set post trigger samples"));
    if (ShowToolTips())
        m_trigger_post_control->SetToolTip(_("Set post trigger samples"));
    itemStaticBoxSizer31->Add(m_trigger_post_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    m_trigger_position_keep_control = new wxCheckBox( m_trigger_panel, ID_TRIGGER_POSITION_KEEP_CHECKBOX, _("Keep position"), wxDefaultPosition, wxDefaultSize, 0 );
    m_trigger_position_keep_control->SetValue(false);
    m_trigger_position_keep_control->SetHelpText(_("Keep trigger postion on screen"));
    if (ShowToolTips())
        m_trigger_position_keep_control->SetToolTip(_("Keep trigger postion on screen"));
    itemStaticBoxSizer31->Add(m_trigger_position_keep_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticBox* itemStaticBoxSizer34Static = new wxStaticBox(m_trigger_panel, wxID_ANY, _("Edge"));
    wxStaticBoxSizer* itemStaticBoxSizer34 = new wxStaticBoxSizer(itemStaticBoxSizer34Static, wxHORIZONTAL);
    itemBoxSizer30->Add(itemStaticBoxSizer34, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 2);
    wxString* m_trigger_edge_controlStrings = NULL;
    m_trigger_edge_control = new wxChoice( m_trigger_panel, ID_TRIGGER_EDGE_CHOICE, wxDefaultPosition, m_trigger_panel->ConvertDialogToPixels(wxSize(80, -1)), 0, m_trigger_edge_controlStrings, 0 );
    m_trigger_edge_control->SetStringSelection(_("NO TRIG"));
    m_trigger_edge_control->SetHelpText(_("Select trigger edge"));
    if (ShowToolTips())
        m_trigger_edge_control->SetToolTip(_("Select trigger edge"));
    m_trigger_edge_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Arial")));
    itemStaticBoxSizer34->Add(m_trigger_edge_control, 0, wxALIGN_CENTER_VERTICAL|wxTOP, 3);

    wxStaticBox* itemStaticBoxSizer36Static = new wxStaticBox(m_trigger_panel, wxID_ANY, _("Channels"));
    wxStaticBoxSizer* itemStaticBoxSizer36 = new wxStaticBoxSizer(itemStaticBoxSizer36Static, wxVERTICAL);
    m_trigger_main_sizer->Add(itemStaticBoxSizer36, 0, wxGROW|wxALL, 5);
    itemStaticBoxSizer36->Add(4, 1, 0, wxGROW|wxALL, 0);

    wxStaticText* itemStaticText38 = new wxStaticText( m_trigger_panel, wxID_STATIC, _("Threshold (mV):"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText38->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer36->Add(itemStaticText38, 0, wxALIGN_RIGHT|wxALL|wxADJUST_MINSIZE, 5);

    wxStaticText* itemStaticText39 = new wxStaticText( m_trigger_panel, wxID_STATIC, _("Thr. samples :"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText39->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer36->Add(itemStaticText39, 0, wxALIGN_RIGHT|wxALL|wxADJUST_MINSIZE, 5);

    m_trigger_panel->FitInside();
    m_common_settings_notebook->AddPage(m_trigger_panel, _("TRIGGER"));

    m_record_panel = new wxScrolledWindow( m_common_settings_notebook, ID_RECORD_SCROLLEDWINDOW, wxDefaultPosition, m_common_settings_notebook->ConvertDialogToPixels(wxSize(133, 43)), wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    m_record_panel->SetScrollbars(1, 1, 1, 1);
    m_record_main_sizer = new wxBoxSizer(wxHORIZONTAL);
    m_record_panel->SetSizer(m_record_main_sizer);

    wxBoxSizer* itemBoxSizer42 = new wxBoxSizer(wxVERTICAL);
    m_record_main_sizer->Add(itemBoxSizer42, 0, wxALIGN_TOP|wxALL, 5);
    m_record_start_stop_control = new wxToggleButton( m_record_panel, ID_RECORDTOGGLEBUTTON, _("Start"), wxDefaultPosition, wxDefaultSize, 0 );
    m_record_start_stop_control->SetValue(false);
    m_record_start_stop_control->SetHelpText(_("Start/ stop recording"));
    if (ShowToolTips())
        m_record_start_stop_control->SetToolTip(_("Start/ stop recording"));
    m_record_start_stop_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemBoxSizer42->Add(m_record_start_stop_control, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticText* itemStaticText44 = new wxStaticText( m_record_panel, wxID_STATIC, _("Folder :"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText44->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemBoxSizer42->Add(itemStaticText44, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

    m_record_folder_sizer = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer42->Add(m_record_folder_sizer, 1, wxGROW|wxALL, 2);
    m_record_dir_control = new wxTextCtrl( m_record_panel, ID_RECORDDIRTEXTCTRL, _T(""), wxDefaultPosition, wxDefaultSize, 0 );
    m_record_dir_control->SetHelpText(_("Insert the folder where to store record files"));
    if (ShowToolTips())
        m_record_dir_control->SetToolTip(_("Insert the folder where to store record files"));
    m_record_folder_sizer->Add(m_record_dir_control, 1, wxALIGN_CENTER_VERTICAL|wxALL, 2);

    m_record_dir_browse_button = new wxButton( m_record_panel, ID_RECORDDIRBUTTON, _("..."), wxDefaultPosition, m_record_panel->ConvertDialogToPixels(wxSize(13, -1)), 0 );
    m_record_dir_browse_button->SetHelpText(_("Select a recording folder"));
    if (ShowToolTips())
        m_record_dir_browse_button->SetToolTip(_("Select a recording folder"));
    m_record_dir_browse_button->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Tahoma")));
    m_record_folder_sizer->Add(m_record_dir_browse_button, 0, wxALIGN_CENTER_VERTICAL|wxALL, 2);

    wxStaticBox* itemStaticBoxSizer48Static = new wxStaticBox(m_record_panel, wxID_ANY, _("Channels"));
    wxStaticBoxSizer* itemStaticBoxSizer48 = new wxStaticBoxSizer(itemStaticBoxSizer48Static, wxVERTICAL);
    m_record_main_sizer->Add(itemStaticBoxSizer48, 0, wxGROW|wxALL, 5);
    itemStaticBoxSizer48->Add(4, 1, 0, wxGROW|wxALL, 0);

    wxStaticText* itemStaticText50 = new wxStaticText( m_record_panel, wxID_STATIC, _("Enable :"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText50->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer48->Add(itemStaticText50, 0, wxALIGN_RIGHT|wxALL|wxADJUST_MINSIZE, 5);

    wxStaticText* itemStaticText51 = new wxStaticText( m_record_panel, wxID_STATIC, _("Rate divider :"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText51->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer48->Add(itemStaticText51, 0, wxALIGN_RIGHT|wxALL|wxADJUST_MINSIZE, 5);

    wxStaticText* itemStaticText52 = new wxStaticText( m_record_panel, wxID_STATIC, _("File format :"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText52->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer48->Add(itemStaticText52, 0, wxALIGN_RIGHT|wxALL|wxADJUST_MINSIZE, 5);

    m_record_panel->FitInside();
    m_common_settings_notebook->AddPage(m_record_panel, _("RECORD"));

    wxBoxSizer* itemBoxSizer53 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer53, 1, wxGROW|wxALL, 0);

    m_left_pane = new wxSashLayoutWindow( itemFrame1, ID_SASHLAYOUTWINDOW, wxDefaultPosition, itemFrame1->ConvertDialogToPixels(wxSize(176, 61)), wxSW_3DBORDER|wxSW_3DSASH|wxNO_BORDER );
    m_left_pane->SetSashVisible(wxSASH_RIGHT, true);
    m_left_pane->SetOrientation(wxLAYOUT_VERTICAL);
    m_left_pane->SetAlignment(wxLAYOUT_LEFT);
    m_left_pane->SetDefaultSize(itemFrame1->ConvertDialogToPixels(wxSize(176, 61)));
    m_left_pane->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Verdana")));
    itemBoxSizer53->Add(m_left_pane, 0, wxGROW|wxALL, 0);

    m_specific_settings_notebook = new wxNotebook( m_left_pane, ID_LEFT_NOTEBOOK, wxDefaultPosition, m_left_pane->ConvertDialogToPixels(wxSize(150, -1)), wxNB_TOP );

    m_view_panel = new wxScrolledWindow( m_specific_settings_notebook, ID_VIEW_SCROLLEDWINDOW, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    m_view_panel->SetScrollbars(1, 1, 1, 1);
    m_view_main_sizer = new wxBoxSizer(wxVERTICAL);
    m_view_panel->SetSizer(m_view_main_sizer);

    wxStaticBox* itemStaticBoxSizer58Static = new wxStaticBox(m_view_panel, wxID_ANY, _("Background"));
    wxStaticBoxSizer* itemStaticBoxSizer58 = new wxStaticBoxSizer(itemStaticBoxSizer58Static, wxHORIZONTAL);
    m_view_main_sizer->Add(itemStaticBoxSizer58, 0, wxGROW|wxLEFT|wxRIGHT, 6);
    m_back_color_control = new wxPanel( m_view_panel, ID_PANEL, wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(20, 9)), wxSIMPLE_BORDER|wxTAB_TRAVERSAL );
    itemStaticBoxSizer58->Add(m_back_color_control, 0, wxALIGN_CENTER_VERTICAL|wxALL, 1);

    wxButton* itemButton60 = new wxButton( m_view_panel, ID_BACK_CHOOSE_COLOR_BUTTON, _("..."), wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(20, 12)), 0 );
    itemButton60->SetHelpText(_("Choose background color"));
    if (ShowToolTips())
        itemButton60->SetToolTip(_("Choose background color"));
    itemButton60->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer58->Add(itemButton60, 0, wxALIGN_CENTER_VERTICAL|wxALL, 1);

    m_main_sizer_text = new wxStaticBox(m_view_panel, wxID_ANY, _("Horizontal"));
    wxStaticBoxSizer* itemStaticBoxSizer61 = new wxStaticBoxSizer(m_main_sizer_text, wxHORIZONTAL);
    m_view_main_sizer->Add(itemStaticBoxSizer61, 0, wxGROW|wxALL, 0);
    m_offset_sec_control = new wxSpinCtrl( m_view_panel, ID_OFFSET_SEC_SPINCTRL, _T("0"), wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(66, -1)), wxSP_ARROW_KEYS, -99999999, 99999999, 0 );
    m_offset_sec_control->SetHelpText(_("Set time scale offset (uSec)"));
    if (ShowToolTips())
        m_offset_sec_control->SetToolTip(_("Set time scale offset (uSec)"));
    itemStaticBoxSizer61->Add(m_offset_sec_control, 0, wxALIGN_CENTER_VERTICAL|wxTOP, 1);

    wxStaticBox* itemStaticBoxSizer63Static = new wxStaticBox(m_view_panel, wxID_ANY, _("Grid"));
    wxStaticBoxSizer* itemStaticBoxSizer63 = new wxStaticBoxSizer(itemStaticBoxSizer63Static, wxHORIZONTAL);
    m_view_main_sizer->Add(itemStaticBoxSizer63, 0, wxGROW|wxLEFT|wxRIGHT|wxBOTTOM, 6);
    m_grid_color_control = new wxPanel( m_view_panel, ID_GRID_COLOR_PANEL, wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(20, 9)), wxSIMPLE_BORDER|wxTAB_TRAVERSAL );
    itemStaticBoxSizer63->Add(m_grid_color_control, 0, wxALIGN_CENTER_VERTICAL|wxALL, 1);

    wxButton* itemButton65 = new wxButton( m_view_panel, ID_GRID_CHOOSE_COLOR_BUTTON, _("..."), wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(20, 12)), 0 );
    itemButton65->SetHelpText(_("Choose grid color"));
    if (ShowToolTips())
        itemButton65->SetToolTip(_("Choose grid color"));
    itemButton65->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    itemStaticBoxSizer63->Add(itemButton65, 0, wxALIGN_CENTER_VERTICAL|wxALL, 1);

    m_grid_line_width_control = new wxSpinCtrl( m_view_panel, ID_GRID_LINE_WIDTH_SPINCTRL, _T("1"), wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(30, -1)), wxSP_ARROW_KEYS, 1, 20, 1 );
    m_grid_line_width_control->SetHelpText(_("Set grid line width"));
    if (ShowToolTips())
        m_grid_line_width_control->SetToolTip(_("Set grid line width"));
    itemStaticBoxSizer63->Add(m_grid_line_width_control, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 1);

    wxString* m_grid_line_type_controlStrings = NULL;
    m_grid_line_type_control = new wxChoice( m_view_panel, ID_GRID_LINE_TYPE_CHOICE, wxDefaultPosition, m_view_panel->ConvertDialogToPixels(wxSize(33, -1)), 0, m_grid_line_type_controlStrings, 0 );
    m_grid_line_type_control->SetHelpText(_("Set grid line type"));
    if (ShowToolTips())
        m_grid_line_type_control->SetToolTip(_("Set grid line type"));
    m_grid_line_type_control->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Arial")));
    itemStaticBoxSizer63->Add(m_grid_line_type_control, 1, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 2);

    m_view_panel->FitInside();
    m_specific_settings_notebook->AddPage(m_view_panel, _("VIEW"));

    m_cursor_panel = new wxScrolledWindow( m_specific_settings_notebook, ID_CURSOR_SCROLLEDWINDOW, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    m_cursor_panel->SetScrollbars(1, 1, 1, 1);
    m_cursor_main_sizer = new wxBoxSizer(wxVERTICAL);
    m_cursor_panel->SetSizer(m_cursor_main_sizer);

    m_cursor_panel->FitInside();
    m_specific_settings_notebook->AddPage(m_cursor_panel, _("CURSORS"));

    m_top_pane = new wxSashLayoutWindow( itemFrame1, ID_SASHLAYOUTWINDOW1, wxDefaultPosition, itemFrame1->ConvertDialogToPixels(wxSize(200, 184)), wxSW_3DBORDER|wxSW_3DSASH|wxNO_BORDER );
    m_top_pane->SetOrientation(wxLAYOUT_HORIZONTAL);
    m_top_pane->SetAlignment(wxLAYOUT_TOP);
    m_top_pane->SetDefaultSize(itemFrame1->ConvertDialogToPixels(wxSize(200, 184)));
    m_top_pane->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxNORMAL, false, _T("Verdana")));
    itemBoxSizer53->Add(m_top_pane, 1, wxGROW|wxALL, 0);

    m_scope_notebook = new wxNotebook( m_top_pane, ID_SCOPE_NOTEBOOK, wxDefaultPosition, wxDefaultSize, wxNB_TOP );

    m_main_toolbar = CreateToolBar( wxTB_FLAT|wxTB_HORIZONTAL|wxTB_TEXT|wxWANTS_CHARS, ID_MAIN_TOOLBAR );
    m_main_toolbar->SetToolBitmapSize(wxSize(34, 34));
    wxBitmap itemtool73Bitmap(itemFrame1->GetBitmapResource(wxT("exit_34.png")));
    wxBitmap itemtool73BitmapDisabled;
    m_main_toolbar->AddTool(ID_EXIT_TOOL, _("Exit"), itemtool73Bitmap, itemtool73BitmapDisabled, wxITEM_NORMAL, _("Close application and exit to system."), _("Close application and exit to system."));
    m_main_toolbar->AddSeparator();
    wxBitmap itemtool75Bitmap(itemFrame1->GetBitmapResource(wxT("view_left_34.PNG")));
    wxBitmap itemtool75BitmapDisabled;
    m_main_toolbar->AddTool(ID_VIEW_LEFT_TOOL, _("Left"), itemtool75Bitmap, itemtool75BitmapDisabled, wxITEM_CHECK, _("Show/Hide left pane"), _("Show/Hide left pane"));
    wxBitmap itemtool76Bitmap(itemFrame1->GetBitmapResource(wxT("view_bottom_34.PNG")));
    wxBitmap itemtool76BitmapDisabled;
    m_main_toolbar->AddTool(ID_VIEW_BOTTOM_TOOL, _("Bottom"), itemtool76Bitmap, itemtool76BitmapDisabled, wxITEM_CHECK, _("Show/Hide bottom pane"), _("Show/Hide bottom pane"));
    m_main_toolbar->AddSeparator();
    wxBitmap itemtool78Bitmap(itemFrame1->GetBitmapResource(wxT("about_34.png")));
    wxBitmap itemtool78BitmapDisabled;
    m_main_toolbar->AddTool(ID_HELP_TOOL, _("About"), itemtool78Bitmap, itemtool78BitmapDisabled, wxITEM_NORMAL, _("About CAEN scope"), _("About CAEN scope"));
    m_main_toolbar->Realize();
    itemFrame1->SetToolBar(m_main_toolbar);

    m_main_statusbar = new wxStatusBar( itemFrame1, ID_MAIN_STATUSBAR, 0 );
    m_main_statusbar->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Verdana")));
    m_main_statusbar->SetFieldsCount(7);
    int m_main_statusbarWidths[7];
    m_main_statusbarWidths[0] = -1;
    m_main_statusbarWidths[1] = 80;
    m_main_statusbarWidths[2] = 80;
    m_main_statusbarWidths[3] = 80;
    m_main_statusbarWidths[4] = 80;
    m_main_statusbarWidths[5] = 120;
    m_main_statusbarWidths[6] = 60;
    m_main_statusbar->SetStatusWidths(7, m_main_statusbarWidths);
    itemFrame1->SetStatusBar(m_main_statusbar);

	////@end MainFrame content construction
	MainFrame::g_main_statusbar= this->m_main_statusbar;

	//
	// Scope Notebook panel
    this->m_scope_panel = new DrawingPanel( this->m_scope_notebook, ID_DRAWING_PANEL, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
	MainFrame::g_scope_panel= this->m_scope_panel;

    this->m_scope_notebook->AddPage( this->m_scope_panel, _("SCOPE"));
	//
	// Grid line type items
	this->m_grid_line_type_control->Append( _("NO GRID"));
	this->m_grid_line_type_control->Append( _("SOLID"));
	this->m_grid_line_type_control->Append( _("DASHED"));
	this->m_grid_line_type_control->Append( _("DASH-DOT"));
	this->m_grid_line_type_control->Append( _("DOTTED"));

	this->m_grid_line_type_control->SetSelection( 0);

	//
	// Sample block size 
	this->m_size_X_control->Append( _("512"));
	this->m_size_X_control->Append( _("1 K"));
	this->m_size_X_control->Append( _("2 K"));
	this->m_size_X_control->Append( _("4 K"));
	this->m_size_X_control->Append( _("8 K"));
	this->m_size_X_control->Append( _("16 K"));
	this->m_size_X_control->Append( _("32 K"));
	this->m_size_X_control->Append( _("64 K"));
	this->m_size_X_control->Append( _("128 K"));
	this->m_size_X_control->Append( _("256 K"));
	this->m_size_X_control->Append( _("512 K"));

	this->m_size_X_control->SetSelection( 0);


	//
	// Sample block size 
	this->m_sec_per_div_control->Append( _("100 nS"));
	this->m_sec_per_div_control->Append( _("500 nS"));
	this->m_sec_per_div_control->Append( _("  1 uS"));
	this->m_sec_per_div_control->Append( _("  5 uS"));
	this->m_sec_per_div_control->Append( _(" 10 uS"));
	this->m_sec_per_div_control->Append( _(" 50 uS"));
	this->m_sec_per_div_control->Append( _("100 uS"));
	this->m_sec_per_div_control->Append( _("500 uS"));
	this->m_sec_per_div_control->Append( _("  1 mS"));
	this->m_sec_per_div_control->Append( _("  5 mS"));

	this->m_sec_per_div_control->SetSelection( 0);

	this->m_trigger_edge_control->Append( _("NO TRIG"));
	this->m_trigger_edge_control->Append( _("RAISING"));
	this->m_trigger_edge_control->Append( _("FALLING"));

}

/*!
* Should we show tooltips?
*/

bool MainFrame::ShowToolTips()
{
	return true;
}

/*!
* Get bitmap resources
*/

wxBitmap MainFrame::GetBitmapResource( const wxString& name )
{
	// Bitmap retrieval
	////@begin MainFrame bitmap retrieval
    wxUnusedVar(name);
    if (name == _T("exit_34.png"))
    {
        wxBitmap bitmap(_T("exit_34.png"), wxBITMAP_TYPE_PNG);
        return bitmap;
    }
    else if (name == _T("view_left_34.PNG"))
    {
        wxBitmap bitmap(_T("view_left_34.PNG"), wxBITMAP_TYPE_PNG);
        return bitmap;
    }
    else if (name == _T("view_bottom_34.PNG"))
    {
        wxBitmap bitmap(_T("view_bottom_34.PNG"), wxBITMAP_TYPE_PNG);
        return bitmap;
    }
    else if (name == _T("about_34.png"))
    {
        wxBitmap bitmap(_T("about_34.png"), wxBITMAP_TYPE_PNG);
        return bitmap;
    }
    return wxNullBitmap;
	////@end MainFrame bitmap retrieval
}

/*!
* Get icon resources
*/

wxIcon MainFrame::GetIconResource( const wxString& name )
{
	// Icon retrieval
	////@begin MainFrame icon retrieval
    wxUnusedVar(name);
    if (name == _T("scope2.png"))
    {
        wxIcon icon(_T("scope2.png"), wxBITMAP_TYPE_PNG);
        return icon;
    }
    return wxNullIcon;
	////@end MainFrame icon retrieval
}
/*!
* wxEVT_COMMAND_MENU_SELECTED event handler for ID_EXIT_TOOL
*/

void MainFrame::OnExitToolClick( wxCommandEvent& /* event*/ )
{
	this->Close();
}


/*!
* wxEVT_SASH_DRAGGED event handler for ID_SASHLAYOUTWINDOW
*/

void MainFrame::OnLeftWindowSashDragged( wxSashEvent& event )
{
	if (event.GetDragStatus() == wxSASH_STATUS_OUT_OF_RANGE)
		return;

	this->m_left_pane->SetDefaultSize(wxSize(event.GetDragRect().width, 1000));
#if wxUSE_MDI_ARCHITECTURE
	wxLayoutAlgorithm layout;
	layout.LayoutFrame(this);
#endif // wxUSE_MDI_ARCHITECTURE
	this->ScopeRefresh( false);
}

/*!
* wxEVT_SIZE event handler for ID_MAIN_FRAME
*/

void MainFrame::OnSize( wxSizeEvent& /* event*/ )
{
#if wxUSE_MDI_ARCHITECTURE
	wxLayoutAlgorithm layout;
	layout.LayoutFrame(this);
#endif // wxUSE_MDI_ARCHITECTURE
	this->ScopeRefresh( false);
}


/*!
 * wxEVT_SASH_DRAGGED event handler for ID_SASHLAYOUTWINDOW2
 */

void MainFrame::OnBottomWindowSashDragged( wxSashEvent& event )
{
	if (event.GetDragStatus() == wxSASH_STATUS_OUT_OF_RANGE)
		return;

	this->m_bottom_pane->SetDefaultSize( wxSize( 1000, event.GetDragRect().height));
#if wxUSE_MDI_ARCHITECTURE
	wxLayoutAlgorithm layout;
	layout.LayoutFrame(this);
#endif // wxUSE_MDI_ARCHITECTURE
	this->ScopeRefresh( false);
}


/*!
 * wxEVT_CLOSE_WINDOW event handler for ID_MAIN_FRAME
 */

void MainFrame::OnCloseWindow( wxCloseEvent& event )
{
	if( this->m_app_settings)
	{
		{
    		wxMutexLocker lock( this->m_app_settings->m_mutex);
			for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
			{
				::wxMutexGuiLeave();
				(( GenericBoard*)this->m_app_settings->m_board_array[i])->DoStopRunning();
			}
			this->m_scope_panel->Freeze();
			this->m_app_settings->Save();
		}
		delete this->m_app_settings;
		this->m_app_settings= NULL;
	}
    event.Skip();
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_COMMON_RUN_TOGGLEBUTTON
 */

void MainFrame::OnCommonRunTogglebuttonClick( wxCommandEvent& /* event*/ )
{
	this->m_common_run_control->SetLabel( this->m_common_run_control->GetValue()? _("Stop"): _("Run"));
	MainFrame::SetStsBarText( this->m_common_run_control->GetValue() ? _("RUN"): _(""), STS_BAR_PANE_RUN);
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		((GenericBoard*) this->m_app_settings->m_board_array[i])->WriteTriggerMode( this->m_common_run_control->GetValue()!= 0);
		if( this->m_common_run_control->GetValue()!= 0)
			((GenericBoard*) this->m_app_settings->m_board_array[i])->DoStartRunning();
		else
        {
            ::wxMutexGuiLeave();
			((GenericBoard*) this->m_app_settings->m_board_array[i])->DoStopRunning();
	}
	}
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_TRIGGER_FORCE_BUTTON
 */

void MainFrame::OnTriggerForceButtonClick( wxCommandEvent& /* event*/ )
{
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		((GenericBoard*) this->m_app_settings->m_board_array[i])->WriteSoftwareTrigger();
	}
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_TRIGGER_AUTO_TOGGLEBUTTON
 */

void MainFrame::OnTriggerAutoTogglebuttonClick( wxCommandEvent& /* event*/ )
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	int msk= this->m_app_settings->m_trigger_msk;
	if( this->m_trigger_auto_control->GetValue())
		msk|= (int)AppSettings::SW_AUTO_TRIGGER_MSK;
	else
		msk&= ~(int)AppSettings::SW_AUTO_TRIGGER_MSK;
	this->m_app_settings->m_trigger_msk= (AppSettings::TRIGGER_MSK)msk;
	this->ScopeRefresh( false);
	MainFrame::SetStsBarText( this->m_trigger_auto_control->GetValue() ? _("AUTO TRIG"): _(""), STS_BAR_PANE_AUTO_TRIG);
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_TRIGGER_EXT_TOGGLEBUTTON
 */

void MainFrame::OnTriggerExtTogglebuttonClick( wxCommandEvent& /* event */)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	int msk= this->m_app_settings->m_trigger_msk;
	if( this->m_trigger_ext_control->GetValue())
		msk|= (int)AppSettings::EXT_TRIGGER_MSK;
	else
		msk&= ~(int)AppSettings::EXT_TRIGGER_MSK;
	this->m_app_settings->m_trigger_msk= (AppSettings::TRIGGER_MSK)msk;
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		((GenericBoard*) this->m_app_settings->m_board_array[i])->WriteTriggerMode( this->m_common_run_control->GetValue()!= 0);
	}
	this->ScopeRefresh( false);
	MainFrame::SetStsBarText( this->m_trigger_ext_control->GetValue() ? _("EXT TRIG"): _(""), STS_BAR_PANE_EXT_TRIG);

}

/*!
 * wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_TRIGGER_POST_SPINCTRL
 */

void MainFrame::OnTriggerPostSpinctrlUpdated( wxSpinEvent& event )
{
	this->UpdateTriggerPost( event.GetPosition());
}


/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ID_VIEW_LEFT_TOOL
 */

void MainFrame::OnViewLeftToolClick( wxCommandEvent& /*event */ )
{
	this->m_left_pane->Show( !this->m_left_pane->IsShown( ));
#if wxUSE_MDI_ARCHITECTURE
	wxLayoutAlgorithm layout;
	layout.LayoutFrame(this);
#endif // wxUSE_MDI_ARCHITECTURE
	this->ScopeRefresh( false);
}

/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ID_VIEW_BOTTOM_TOOL
 */

void MainFrame::OnViewBottomToolClick( wxCommandEvent& /* event*/ )
{
	this->m_bottom_pane->Show( !this->m_bottom_pane->IsShown( ));
#if wxUSE_MDI_ARCHITECTURE
	wxLayoutAlgorithm layout;
	layout.LayoutFrame(this);
#endif // wxUSE_MDI_ARCHITECTURE
	this->ScopeRefresh( false);
}
/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_GRID_CHOOSE_COLOR_BUTTON
 */

void MainFrame::OnGridChooseColorButtonClick( wxCommandEvent& /* event*/ )
{
	wxColourData colour_data;
	colour_data.SetColour( this->m_app_settings->m_grid_line_color);
	wxColourDialog *dlg= new wxColourDialog( this, &colour_data);
	dlg->Centre();
	if( dlg->ShowModal()== wxID_OK)
	{
		wxMutexLocker lock( this->m_app_settings->m_mutex);
		this->m_app_settings->m_grid_line_color= dlg->GetColourData().GetColour();
		this->m_grid_color_control->SetBackgroundColour( this->m_app_settings->m_grid_line_color);
		this->m_grid_color_control->Refresh();
		this->UpdateGrid();
	}
	delete dlg;
}
bool MainFrame::UpdateControls( void)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);

	// Background controls
	this->m_back_color_control->SetBackgroundColour( this->m_app_settings->m_background_color);
	this->m_back_color_control->Refresh();
	wxBrush back_brush= wxBrush( this->m_app_settings->m_background_color);
	this->m_app_settings->SetBackBrush( &back_brush);

	// Grid controls
	this->m_grid_line_type_control->SetSelection( (int)this->m_app_settings->m_grid_line_type);
	this->m_grid_line_width_control->SetValue( (int)this->m_app_settings->m_grid_line_width);
	this->m_grid_color_control->SetBackgroundColour( this->m_app_settings->m_grid_line_color);
	this->m_grid_color_control->Refresh();
	this->UpdateGrid();

	// Trigger controls
	this->m_trigger_ext_control->SetValue( (this->m_app_settings->m_trigger_msk& AppSettings::EXT_TRIGGER_MSK)!= 0);
	this->m_trigger_auto_control->SetValue( (this->m_app_settings->m_trigger_msk& AppSettings::SW_AUTO_TRIGGER_MSK)!= 0);
	this->m_trigger_post_control->SetValue( this->m_app_settings->m_post_trigger);
	this->m_trigger_edge_control->SetSelection( this->m_app_settings->m_trigger_edge_type);
	this->UpdateTriggerEdge();

	// Record controls
	this->m_record_dir_control->SetValue( this->m_app_settings->m_record_folder);
	this->UpdateRecordFolder();

	// Common controls
	this->m_size_X_control->SetSelection( this->m_app_settings->m_sample_block_size);

	// Get best combo selection for sec_2_div setting
	double sec_per_div= 1/ this->m_app_settings->m_sec_2_div;
	const int num_sels= sizeof( SEC_PER_DIV_TABLE)/sizeof( SEC_PER_DIV_TABLE[0]);
	for( int i= 1; i< num_sels; i++)
	{
		if( ( SEC_PER_DIV_TABLE[i-1]<= sec_per_div)&& 
			( SEC_PER_DIV_TABLE[i]>= sec_per_div))
		{
			if(( sec_per_div- SEC_PER_DIV_TABLE[i-1])< ( SEC_PER_DIV_TABLE[i]- sec_per_div))
			{
				this->m_sec_per_div_control->SetSelection( i- 1);
			}
			else
			{
				this->m_sec_per_div_control->SetSelection( i);
			}
			break;
		}
	}

	this->m_app_settings->m_max_log_X= ( (int)pow( 2, this->m_app_settings->m_sample_block_size))<< 9;
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		(( GenericBoard*)this->m_app_settings->m_board_array[i])->WriteSampleBufferSize();
	}

	this->m_offset_sec_control->SetValue( (int)(double)( this->m_app_settings->m_offset_sec* 1000000.0));
	this->m_use_ext_clock_control->SetValue( this->m_app_settings->m_use_ext_clock);
	this->m_ext_clock_control->SetValue( this->m_app_settings->m_ext_rate_MHz);

	this->AdjustTriggerPost();
	this->m_trigger_position_keep_control->SetValue( this->m_app_settings->m_trigger_position_keep);

	this->m_common_TTL_control->SetValue( this->m_app_settings->m_use_TTL);
	this->UpdateUseTTL();

	this->ScopeRefresh( true);

	// Status bar update
	MainFrame::SetStsBarText( this->m_app_settings->m_use_ext_clock? _("EXT CLK"): _(""), STS_BAR_PANE_EXT_CLOCK);
	MainFrame::SetStsBarText( this->m_trigger_ext_control->GetValue() ? _("EXT TRIG"): _(""), STS_BAR_PANE_EXT_TRIG);
	MainFrame::SetStsBarText( this->m_trigger_auto_control->GetValue() ? _("AUTO TRIG"): _(""), STS_BAR_PANE_AUTO_TRIG);

	return true;
}
bool MainFrame::UpdateGrid( void)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	int wx_pen_style= wxSOLID;
	switch( this->m_app_settings->m_grid_line_type)
	{
	case AppSettings::NO_LINE:
		if( !this->m_app_settings->SetGridPen( NULL))
			return false;
		this->ScopeRefresh( true);
		return true;
	case AppSettings::DASHED:
		wx_pen_style= wxSHORT_DASH;
		break;
	case AppSettings::DOTTED:
		wx_pen_style= wxDOT;
		break;
	case AppSettings::DASH_DOT:
		wx_pen_style= wxDOT_DASH;
		break;
	case AppSettings::SOLID:
	default:
		wx_pen_style= wxSOLID;
		break;
	}
	wxPen grid_pen= wxPen( this->m_app_settings->m_grid_line_color, this->m_app_settings->m_grid_line_width, wx_pen_style);

//	wxPen mid_grid_pen= wxPen( this->m_app_settings->m_grid_line_color, ( this->m_app_settings->m_grid_line_width<= 2)? 3: this->m_app_settings->m_grid_line_width<< 1, wx_pen_style);
	wxPen mid_grid_pen= wxPen( this->m_app_settings->m_grid_line_color, this->m_app_settings->m_grid_line_width+ 1, wx_pen_style);
	if( !this->m_app_settings->SetGridPen( &grid_pen, &mid_grid_pen))
		return false;
	this->ScopeRefresh( true);
	return true;
}

/*!
 * wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_GRID_LINE_WIDTH_SPINCTRL
 */

void MainFrame::OnGridLineWidthSpinctrlUpdated( wxSpinEvent& event )
{
	this->UpdateGridLineWidth( event.GetPosition());
}


/*!
 * wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_GRID_LINE_TYPE_CHOICE
 */

void MainFrame::OnGridLineTypeChoiceSelected( wxCommandEvent& /* event*/ )
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	this->m_app_settings->m_grid_line_type= ( AppSettings::GRID_LINE_TYPE)this->m_grid_line_type_control->GetSelection();
	this->UpdateGrid();
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON
 */

void MainFrame::OnBackChooseColorButtonClick( wxCommandEvent& /* event*/ )
{
	wxColourData colour_data;
	colour_data.SetColour( this->m_app_settings->m_background_color);
	wxColourDialog *dlg= new wxColourDialog( this, &colour_data);
	dlg->Centre();
	if( dlg->ShowModal()== wxID_OK)
	{
		wxMutexLocker lock( this->m_app_settings->m_mutex);
		this->m_app_settings->m_background_color= dlg->GetColourData().GetColour();
		this->m_back_color_control->SetBackgroundColour( this->m_app_settings->m_background_color);
		this->m_back_color_control->Refresh();
		wxBrush back_brush= wxBrush( this->m_app_settings->m_background_color);
		this->m_app_settings->SetBackBrush( &back_brush);
		this->ScopeRefresh( true);
	}
	delete dlg;
}


void MainFrame:: ScopeRefresh( bool erase_background)
{
	if( MainFrame::g_scope_panel!= NULL)
	{
		if( erase_background)
		{
			MainFrame::g_scope_panel->RefreshBackBitmap();
			MainFrame::g_scope_panel->RefreshLeftBackBitmap();
		}
#ifndef __WXMSW__
        if( !::wxIsMainThread())
            ::wxMutexGuiEnter();
#endif
		MainFrame::g_scope_panel->Refresh();
#ifndef __WXMSW__
        if( !::wxIsMainThread())
            ::wxMutexGuiLeave();
#endif
	}
}


/*!
 * wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_SIZE_X_CHOICE
 */

void MainFrame::OnSizeXChoiceSelected( wxCommandEvent& /* event*/ )
{
	this->m_app_settings->m_sample_block_size= this->m_size_X_control->GetSelection();
	this->m_app_settings->m_max_log_X= ( (int)pow( 2, this->m_app_settings->m_sample_block_size))<< 9;

	this->AdjustTriggerPost();

	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		(( GenericBoard*)this->m_app_settings->m_board_array[i])->WriteSampleBufferSize();
	}

	this->ScopeRefresh( true);
}


/*!
 * wxEVT_COMMAND_TEXT_UPDATED event handler for ID_GRID_LINE_WIDTH_SPINCTRL
 */

void MainFrame::OnGridLineWidthSpinctrlTextUpdated( wxCommandEvent& /* event*/ )
{
    int value= atoi( this->m_grid_line_width_control->GetLabel());
	this->UpdateGridLineWidth( value);
}

void MainFrame::UpdateGridLineWidth( int value)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	this->m_app_settings->m_grid_line_width= value;
	this->UpdateGrid();
}


/*!
 * wxEVT_COMMAND_TEXT_UPDATED event handler for ID_TRIGGER_POST_SPINCTRL
 */

void MainFrame::OnTriggerPostSpinctrlTextUpdated( wxCommandEvent& /* event*/ )
{
    int value= atoi( this->m_trigger_post_control->GetLabel());
	this->UpdateTriggerPost( value);
}

void MainFrame::UpdateTriggerPost( int value)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	this->m_app_settings->m_post_trigger= value;
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		((GenericBoard*) this->m_app_settings->m_board_array[i])->WriteTriggerMode( this->m_common_run_control->GetValue()!= 0);
	}
	this->ScopeRefresh( true);
}

/*!
 * wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_SEC_PER_DIV_CHOICE
 */

void MainFrame::OnSecPerDivChoiceSelected( wxCommandEvent& /* event*/ )
{
	this->UpdateSecPerDiv();
}
void MainFrame::UpdateSecPerDiv( void)
{
	int selection= this->m_sec_per_div_control->GetSelection();
	if( selection>= sizeof( SEC_PER_DIV_TABLE)/sizeof( SEC_PER_DIV_TABLE[0]))
		return;
	if( this->m_app_settings->m_trigger_position_keep)
	{
		double sec_2_div_old= this->m_app_settings->m_sec_2_div;
		double sample_2_sec_old= this->m_app_settings->m_sample_2_sec;
		this->m_app_settings->SetSec2Div( 1.0/ SEC_PER_DIV_TABLE[ selection]);
		// recalculate offset to keep trigger position fixed on screen
		double fix_old= sec_2_div_old*( this->m_app_settings->m_offset_sec+ sample_2_sec_old*( this->m_app_settings->m_max_log_X- this->m_app_settings->m_post_trigger));
		this->m_app_settings->m_offset_sec= fix_old/ this->m_app_settings->m_sec_2_div- this->m_app_settings->m_sample_2_sec*( this->m_app_settings->m_max_log_X- this->m_app_settings->m_post_trigger);
		this->m_offset_sec_control->SetValue( (int)(double)( this->m_app_settings->m_offset_sec* 1000000.0));
	}
	else
	{
		this->m_app_settings->SetSec2Div( 1.0/ SEC_PER_DIV_TABLE[ selection]);
	}
	this->ScopeRefresh( true);
}


/*!
 * wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_OFFSET_SEC_SPINCTRL
 */

void MainFrame::OnOffsetSecSpinctrlUpdated( wxSpinEvent& event )
{
	this->UpdateOffsetSec( event.GetPosition());
}

/*!
 * wxEVT_COMMAND_TEXT_UPDATED event handler for ID_OFFSET_SEC_SPINCTRL
 */

void MainFrame::OnOffsetSecSpinctrlTextUpdated( wxCommandEvent& /* event*/ )
{
    int value= atoi( this->m_offset_sec_control->GetLabel());
	this->UpdateOffsetSec( value);
}

void MainFrame::UpdateOffsetSec( int value)
{
    wxMutexLocker lock( this->m_app_settings->m_mutex);
    this->m_app_settings->m_offset_sec= (double)value/ 1000000.0;

	this->ScopeRefresh( true);
}

bool MainFrame::UpdateRecordFolder( void)
{
	if( !wxDir::Exists( this->m_record_dir_control->GetValue()))
		return false;
	this->m_app_settings->m_record_folder= this->m_record_dir_control->GetValue();
	this->m_record_dir_control->SetBackgroundColour(wxColour(255, 255, 255));
	this->m_record_dir_control->SetToolTip( this->m_record_dir_control->GetValue());
	this->m_record_dir_control->Refresh( true);
	return true;
}

/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_RECORDTOGGLEBUTTON
 */

void MainFrame::OnRecordtogglebuttonClick( wxCommandEvent& /*event */)
{
	wxString path= this->m_record_dir_control->GetValue();
	wxString file_name= _("caen_scope_");
	wxString date= wxDateTime::Now().FormatISODate();
	date.Replace( "-", "_");
	wxString time= wxDateTime::Now().FormatISOTime();
	time.Replace( ":", "_");
	wxString timestamp( wxString::Format( "%s_%s", date.c_str(), time.c_str()));
	bool start= this->m_record_start_stop_control->GetValue();
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
		{
		(( GenericBoard *)this->m_app_settings->m_board_array[i])->ToggleRecordStatus( path, file_name, timestamp, start);
	}
	this->m_record_dir_browse_button->Enable( !start);
	this->m_record_dir_control->Enable( !start);
	this->m_record_start_stop_control->SetLabel( this->m_record_start_stop_control->GetValue( )? _("Stop"): _("Start"));
	MainFrame::SetStsBarText( this->m_record_start_stop_control->GetValue( ) ? _("REC"): _(""), STS_BAR_PANE_REC);

}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_RECORDDIRBUTTON
 */

void MainFrame::OnRecorddirbuttonClick( wxCommandEvent& /*event*/ )
{
	// Show directory browse folder
	wxFileName org_dir( this->m_record_dir_control->GetValue());
	org_dir.Normalize();
	wxDirDialog dlg( this, "Choose a directory for recording", org_dir.GetFullPath());
	if( dlg.ShowModal()!= wxID_OK )
		return;
	this->m_record_dir_control->SetValue( dlg.GetPath());

	this->UpdateRecordFolder();
}


/*!
 * wxEVT_COMMAND_TEXT_UPDATED event handler for ID_RECORDDIRTEXTCTRL
 */

void MainFrame::OnRecorddirtextctrlUpdated( wxCommandEvent& /* event */)
{
	this->m_record_dir_control->SetBackgroundColour(wxColour(255, 128, 128));
	this->m_record_dir_control->Refresh( true);
}

/*!
 * wxEVT_COMMAND_TEXT_ENTER event handler for ID_RECORDDIRTEXTCTRL
 */

void MainFrame::OnRecorddirtextctrlEnter( wxCommandEvent& /*event*/ )
{
	this->UpdateRecordFolder();
}

/*!
 * wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_SPINCTRL
 */
void MainFrame::OnExtClockSpinctrlUpdated( wxSpinEvent& event )
{
	this->UpdateClock( event.GetPosition());
}

/*!
 * wxEVT_COMMAND_TEXT_UPDATED event handler for ID_SPINCTRL
 */

void MainFrame::OnExtClockSpinctrlTextUpdated( wxCommandEvent& /* event*/ )
{
    int value= atoi( this->m_ext_clock_control->GetLabel());
	this->UpdateClock( value);
}

/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_EXT_CLOCK_CHECKBOX
 */

void MainFrame::OnExtClockCheckboxClick( wxCommandEvent& /*event */)
{
    int value= atoi( this->m_ext_clock_control->GetLabel());
	this->UpdateClock( value);
}

void MainFrame::UpdateClock( int value)
{
	this->m_ext_clock_control->Enable( this->m_use_ext_clock_control->IsChecked());

	// setup AppSettings
	this->m_app_settings->SetClock( this->m_use_ext_clock_control->IsChecked(), value);
	this->ScopeRefresh( true);

	MainFrame::SetStsBarText( this->m_app_settings->m_use_ext_clock? _("EXT CLK"): _(""), STS_BAR_PANE_EXT_CLOCK);
}


/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ID_HELP_TOOL
 */

void MainFrame::OnHelpToolClick( wxCommandEvent& /* event*/ )
{
	InfoDialog dlg( this);
	dlg.ShowModal();
}

bool MainFrame::SetStsBarText( const wxString& text, int pane_index)
{
	if(( pane_index>= STS_BAR_NUM_PANES)|| ( MainFrame::g_main_statusbar== NULL))
		return false;
	//::wxMutexGuiEnter();
	MainFrame::g_main_statusbar->SetStatusText( text, pane_index);
	//::wxMutexGuiLeave();
	return true;
}

/*!
 * wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_TRIGGER_EDGE_CHOICE
 */

void MainFrame::OnTriggerEdgeChoiceSelected( wxCommandEvent& /*event*/ )
{
	this->UpdateTriggerEdge();
}
void MainFrame::UpdateTriggerEdge( void)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	this->m_app_settings->m_trigger_edge_type= ( AppSettings::TRIGGER_EDGE_TYPE)this->m_trigger_edge_control->GetSelection();
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		((GenericBoard*) this->m_app_settings->m_board_array[i])->WriteTriggerMode( this->m_common_run_control->GetValue()!= 0);
	}
	this->ScopeRefresh( true);

	wxString sts_msg= _("");
	switch( this->m_app_settings->m_trigger_edge_type)
	{
	case AppSettings::FALLING_EDGE:
		sts_msg= _("FALLING EDGE");
		break;
	case AppSettings::RAISING_EDGE:
		sts_msg= _("RAISING EDGE");
		break;
	}
	MainFrame::SetStsBarText( sts_msg, STS_BAR_PANE_TRIG_EDGE);
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_TOGGLEBUTTON
 */

void MainFrame::OnFrontPanelNimTogglebuttonClick( wxCommandEvent& /*event*/ )
{
	this->UpdateUseTTL();
}

void MainFrame::UpdateUseTTL( void)
{
	wxMutexLocker lock( this->m_app_settings->m_mutex);
	this->m_app_settings->m_use_TTL= this->m_common_TTL_control->GetValue();
	for( size_t i= 0; i< this->m_app_settings->m_board_array.GetCount(); i++)
	{
		((GenericBoard*) this->m_app_settings->m_board_array[i])->SetFrontPanelIO( this->m_app_settings->m_use_TTL!= 0);
	}
	this->m_common_TTL_control->SetLabel( this->m_app_settings->m_use_TTL? _("NIM"): _("TTL"));
	MainFrame::SetStsBarText( !this->m_app_settings->m_use_TTL? _("NIM"): _("TTL"), STS_BAR_PANE_NIM);
}

void MainFrame::AdjustTriggerPost( void)
{
	int post_trigger= this->m_trigger_post_control->GetValue();
	if( post_trigger>= this->m_app_settings->m_max_log_X)
		this->m_trigger_post_control->SetValue( this->m_app_settings->m_max_log_X- 1);
	this->m_trigger_post_control->SetRange( 0, this->m_app_settings->m_max_log_X- 1);

}
/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_TRIGGER_POSITION_KEEP_CHECKBOX
 */

void MainFrame::OnTriggerPositionKeepCheckboxClick( wxCommandEvent& /*event */)
{
	this->m_app_settings->m_trigger_position_keep= this->m_trigger_position_keep_control->GetValue();
}
